#include <antiglut.h>

#define	DRAW_LIST(v, c, cshift)  /* uses 'i' integer variable */ \
	for(i = 0;i < 3;i++) { \
			glColor4fv((c)[(i + (cshift)) % 3]); \
			glVertex3fv((v)[i]); \
		}

int main()
{
	int i, cshift = 0;
	ui_event_t	ev;
	GLfloat v[3][3] = {{-.866f,-.5f,0},{.866f,-.5f,0},{0,1,0}};
	GLfloat c[3][4] = {{0,0,.5f,.5f},{0,1,0,.5f},{.5f,1,1,.5f}};
	agWindowConfig("Basic AntiGlut demo", 512, 512, GL_FALSE);
	if(!agInit(AG_REQUIRED_1_1, GL_FALSE, GL_FALSE, GL_FALSE))
		return -1;
	glClearColor(1,1,1,.5f);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_LINE_SMOOTH);
	glLineWidth(3);
	while(uiNextEvent(&ev))
	{
		switch(ev.type) {
			case ui_wm_event:
				if(ev.configure.wm_event == ui_wm_close)
					goto outer_break;
			case ui_key_event:
				if(ev.key.scan == sc_escape)
					goto outer_break;
				if(ev.key.scan == sc_p)
					glReadBuffer(GL_FRONT);
					aguSavePPM("outfile.ppm");
					break;
				if(!ev.key.press)
					cshift++;
				/* fall throw */
			case ui_window_expose_event:
				glClear(GL_COLOR_BUFFER_BIT);
				glEnable(GL_BLEND);
				glLoadIdentity();
				glTranslatef(0,-.25,0);
				glBegin(GL_LINE_LOOP);
                    DRAW_LIST(v, c, cshift);
				glEnd();
				glDisable(GL_BLEND);
				glScalef(0.9f,0.9f,0.9f);
				glBegin(GL_TRIANGLES);
                    DRAW_LIST(v, c, 1 + cshift);
				glEnd();
				agSwap();
		}
	}
outer_break:;
	agShutdown();
	return 0;
}
